//---------------------------------------------------------------------------
//#include <vcl.h>
#pragma hdrstop
#include "grapBasic.h"
//#include "ASMVars.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
// Graphic primitives: base class
// Author: Sinia Petri
//---------------------------------------------------------------------------
__fastcall TGrapBasic::TGrapBasic(int imgHeight)
{
_imgHeightM1 = imgHeight - 1;
chunkList = new TObjectList(false);
structPtChunk *cItem;
cItem = new structPtChunk;
cItem->Count = 0;
chunkList->Add((TObject*)cItem);
chunkItem = cItem;
PointBmp = 0;
CountBmp = 0;
PointRaw = 0;
CountRaw = 0;
_Step = 0;
}
//---------------------------------------------------------------------------
// destructor
__fastcall TGrapBasic::~TGrapBasic(void)
{
structPtChunk *cItem;
while (chunkList->Count > 0)
//for (int i = 0; i < chunkList->Count; i++)
    {
    cItem = reinterpret_cast <structPtChunk*>(chunkList->Items[0]);
    delete cItem;
    chunkList->Delete(0);
	}
delete chunkList;
if (PointBmp)
   delete[] PointBmp;
if (PointRaw)
   delete[] PointRaw;
//
}
//---------------------------------------------------------------------------
UnicodeString __fastcall TGrapBasic::ClassName(void)
{
return "TGrapBasic";
}
//---------------------------------------------------------------------------
// public method - virtual
//---------------------------------------------------------------------------
bool __fastcall TGrapBasic::DrawBound(TRect *boundRect)
{
//
return false;
}
//---------------------------------------------------------------------------
// public method - virtual
//---------------------------------------------------------------------------
void __fastcall TGrapBasic::DrawCoords(int X1, int Y1, int X2, int Y2)
{
//
}
//---------------------------------------------------------------------------
// public method - virtual
//---------------------------------------------------------------------------
void __fastcall TGrapBasic::Rotate(TPoint *origin, double angle)
{
structPtChunk *cItem;
for (int i = 0; i < chunkList->Count; i++)
	{
    cItem = reinterpret_cast <structPtChunk*>(chunkList->Items[i]);
	rotatePoints(cItem->Point, cItem->Count, origin, angle);
    }
}
//---------------------------------------------------------------------------
// public method - virtual
//---------------------------------------------------------------------------
void __fastcall TGrapBasic::GetBitmapPoints(int lineStep)
{
int i, j, ptCount = 0;
int chunkSize = getOverallChunkSize(chunkList);
if (PointBmp)
   delete[] PointBmp;
PointBmp = new TPoint[chunkSize];
// collect chunks in one array
structPtChunk *cItem;
for (i = 0; i < chunkList->Count; i++)
    {
    cItem = reinterpret_cast <structPtChunk*>(chunkList->Items[i]);
    for (j = 0; j < cItem->Count; j++)
       {
	   if (++_Step < lineStep)
          continue;
       PointBmp[ptCount].x   = cItem->Point[j].x;
       PointBmp[ptCount++].y = _imgHeightM1 - cItem->Point[j].y;
       _Step = 0;
       }
    }
CountBmp = ptCount;
}
//---------------------------------------------------------------------------
// public method - virtual
//---------------------------------------------------------------------------
void __fastcall TGrapBasic::GetScreenPoints(int lineStep)
{
int i, j, ptCount = 0;
int chunkSize = getOverallChunkSize(chunkList);
if (PointScreen)
   delete[] PointScreen;
PointScreen = new TPoint[chunkSize];
// collect chunks in one array
structPtChunk *cItem;
for (i = 0; i < chunkList->Count; i++)
	{
	cItem = reinterpret_cast <structPtChunk*>(chunkList->Items[i]);
	for (j = 0; j < cItem->Count; j++)
	   {
	   if (++_Step < lineStep)
		  continue;
	   PointRaw[ptCount++]   = cItem->Point[j];
	   _Step = 0;
	   }
	}
CountScreen = ptCount;
}
//---------------------------------------------------------------------------
// public method - virtual
//---------------------------------------------------------------------------
void __fastcall TGrapBasic::GetRawPoints(void)
{
int i, j, ptCount = 0;
int chunkSize = getOverallChunkSize(chunkList);
if (PointRaw)
   delete[] PointRaw;
PointRaw = new TPoint[chunkSize];
// collect chunks in one array
structPtChunk *cItem;
for (i = 0; i < chunkList->Count; i++)
    {
    cItem = reinterpret_cast <structPtChunk*>(chunkList->Items[i]);
    for (j = 0; j < cItem->Count; j++)
       PointRaw[ptCount++]   = cItem->Point[j];
    }
CountRaw = ptCount;
}
//---------------------------------------------------------------------------
// protected method - virtual
//---------------------------------------------------------------------------
void __fastcall TGrapBasic::ResetStepper(int initStep)
{
_Step = initStep;
}
//---------------------------------------------------------------------------
// protected method - virtual
//---------------------------------------------------------------------------
void __fastcall TGrapBasic::Reset(void)
{
clearChunks(chunkList);
}
//---------------------------------------------------------------------------
// protected method
//---------------------------------------------------------------------------
int __fastcall TGrapBasic::getOverallChunkSize(TObjectList *cList)
{
int oSize = 0;
// calculate memory
structPtChunk *cItem;
for (int i = 0; i < cList->Count; i++)
    {
    cItem = reinterpret_cast <structPtChunk*>(cList->Items[i]);
    oSize += cItem->Count;
    }
return oSize;
}
//---------------------------------------------------------------------------
// protected method - virtual
//---------------------------------------------------------------------------
void __fastcall TGrapBasic::savePoint(TObjectList *cList, structPtChunk *cItem, int X, int Y)
{
if (cItem->Count == GP_CHUNK_MAX) // we need a new chunk
   {
   cItem = new structPtChunk;
   cItem->Count = 0;
   chunkList->Add((TObject*)cItem);
   }
cItem->Point[cItem->Count].x   = X;
cItem->Point[cItem->Count++].y = Y;
}
//---------------------------------------------------------------------------
// protected method
//---------------------------------------------------------------------------
void __fastcall TGrapBasic::savePoint(int X, int Y)
{
savePoint(chunkList, chunkItem, X, Y);
}
//---------------------------------------------------------------------------
// protected method
//---------------------------------------------------------------------------
void __fastcall TGrapBasic::clearChunks(TObjectList *cList)
{
structPtChunk *cItem = reinterpret_cast <structPtChunk*>(cList->Items[0]);
cItem->Count = 0;
// clear additional chunks
while (cList->Count > 1)
	{
	cItem = reinterpret_cast <structPtChunk*>(cList->Items[1]);
	delete cItem;
	cList->Delete(1);
	}
}
//---------------------------------------------------------------------------
// protected method
//---------------------------------------------------------------------------
void __fastcall TGrapBasic::rotatePoints(TPoint *points, int points_number, TPoint *origin, double angle)
{
double ox, oy, x1, y1;
ox = origin->x;
oy = origin->y;
for (int i = 0; i < points_number; i++)
	{
	x1 = points[i].x;
	y1 = points[i].y;
	//points[i].x = fast_ftol(ox + (x1 - ox)*cos(angle) - (y1 - oy)*sin(angle));
	//points[i].y = fast_ftol(oy + (x1 - ox)*sin(angle) + (y1 - oy)*cos(angle));
	points[i].x = ceil(ox + (x1 - ox)*cos(angle) - (y1 - oy)*sin(angle));
	points[i].y = ceil(oy + (x1 - ox)*sin(angle) + (y1 - oy)*cos(angle));
	}
}
//---------------------------------------------------------------------------

