//---------------------------------------------------------------------------
#pragma hdrstop
#include "grapLine.h"
#include "ASMVars.h"
#include <math.h>
#include <algorithm>
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
// Graphic primitives: line
// Author: Sinia Petri
//---------------------------------------------------------------------------
__fastcall TGrapLine::TGrapLine(int imgHeight)
           : TGrapBasic(imgHeight)
{
}
//---------------------------------------------------------------------------
// destructor
__fastcall TGrapLine::~TGrapLine(void)
{
}
//---------------------------------------------------------------------------
UnicodeString __fastcall TGrapLine::ClassName(void)
{
return "TGrapLine";
}
//---------------------------------------------------------------------------
// public method - implementation
//---------------------------------------------------------------------------
void __fastcall TGrapLine::DrawCoords(int x0, int y0, int x1, int y1)
{
 // Breshenham's algorithm
int dx = abs(x1-x0), sx = x0<x1 ? 1 : -1;
int dy = abs(y1-y0), sy = y0<y1 ? 1 : -1;
int err = (dx>dy ? dx : -dy)/2, e2;

for(;;)
   {
   savePoint(x0, y0);     // points collector
   if (x0==x1 && y0==y1) break;
   e2 = err;
   if (e2 >-dx) { err -= dy; x0 += sx; }
   if (e2 < dy) { err += dx; y0 += sy; }
  }
}


